drm/radeon: comment out some currently unused 7xx dpm code
[linux/fpc-iii.git] / tools / testing / selftests / ftrace / ftracetest
blobda48812ab95e2fd602762fcbc81443403c32e937
1 #!/bin/sh
3 # ftracetest - Ftrace test shell scripts
5 # Copyright (C) Hitachi Ltd., 2014
6 # Written by Masami Hiramatsu <masami.hiramatsu.pt@hitachi.com>
8 # Released under the terms of the GPL v2.
10 usage() { # errno [message]
11 [ "$2" ] && echo $2
12 echo "Usage: ftracetest [options] [testcase(s)] [testcase-directory(s)]"
13 echo " Options:"
14 echo " -h|--help Show help message"
15 echo " -k|--keep Keep passed test logs"
16 echo " -v|--verbose Show all stdout messages in testcases"
17 echo " -d|--debug Debug mode (trace all shell commands)"
18 exit $1
21 errexit() { # message
22 echo "Error: $1" 1>&2
23 exit 1
26 # Ensuring user privilege
27 if [ `id -u` -ne 0 ]; then
28 errexit "this must be run by root user"
31 # Utilities
32 absdir() { # file_path
33 (cd `dirname $1`; pwd)
36 abspath() {
37 echo `absdir $1`/`basename $1`
40 find_testcases() { #directory
41 echo `find $1 -name \*.tc | sort`
44 parse_opts() { # opts
45 local OPT_TEST_CASES=
46 local OPT_TEST_DIR=
48 while [ "$1" ]; do
49 case "$1" in
50 --help|-h)
51 usage 0
53 --keep|-k)
54 KEEP_LOG=1
55 shift 1
57 --verbose|-v)
58 VERBOSE=1
59 shift 1
61 --debug|-d)
62 DEBUG=1
63 shift 1
65 *.tc)
66 if [ -f "$1" ]; then
67 OPT_TEST_CASES="$OPT_TEST_CASES `abspath $1`"
68 shift 1
69 else
70 usage 1 "$1 is not a testcase"
74 if [ -d "$1" ]; then
75 OPT_TEST_DIR=`abspath $1`
76 OPT_TEST_CASES="$OPT_TEST_CASES `find_testcases $OPT_TEST_DIR`"
77 shift 1
78 else
79 usage 1 "Invalid option ($1)"
82 esac
83 done
84 if [ "$OPT_TEST_CASES" ]; then
85 TEST_CASES=$OPT_TEST_CASES
89 # Parameters
90 DEBUGFS_DIR=`grep debugfs /proc/mounts | cut -f2 -d' ' | head -1`
91 TRACING_DIR=$DEBUGFS_DIR/tracing
92 TOP_DIR=`absdir $0`
93 TEST_DIR=$TOP_DIR/test.d
94 TEST_CASES=`find_testcases $TEST_DIR`
95 LOG_DIR=$TOP_DIR/logs/`date +%Y%m%d-%H%M%S`/
96 KEEP_LOG=0
97 DEBUG=0
98 VERBOSE=0
99 # Parse command-line options
100 parse_opts $*
102 [ $DEBUG -ne 0 ] && set -x
104 # Verify parameters
105 if [ -z "$DEBUGFS_DIR" -o ! -d "$TRACING_DIR" ]; then
106 errexit "No ftrace directory found"
109 # Preparing logs
110 LOG_FILE=$LOG_DIR/ftracetest.log
111 mkdir -p $LOG_DIR || errexit "Failed to make a log directory: $LOG_DIR"
112 date > $LOG_FILE
113 prlog() { # messages
114 echo "$@" | tee -a $LOG_FILE
116 catlog() { #file
117 cat $1 | tee -a $LOG_FILE
119 prlog "=== Ftrace unit tests ==="
122 # Testcase management
123 # Test result codes - Dejagnu extended code
124 PASS=0 # The test succeeded.
125 FAIL=1 # The test failed, but was expected to succeed.
126 UNRESOLVED=2 # The test produced indeterminate results. (e.g. interrupted)
127 UNTESTED=3 # The test was not run, currently just a placeholder.
128 UNSUPPORTED=4 # The test failed because of lack of feature.
129 XFAIL=5 # The test failed, and was expected to fail.
131 # Accumulations
132 PASSED_CASES=
133 FAILED_CASES=
134 UNRESOLVED_CASES=
135 UNTESTED_CASES=
136 UNSUPPORTED_CASES=
137 XFAILED_CASES=
138 UNDEFINED_CASES=
139 TOTAL_RESULT=0
141 CASENO=0
142 testcase() { # testfile
143 CASENO=$((CASENO+1))
144 desc=`grep "^#[ \t]*description:" $1 | cut -f2 -d:`
145 prlog -n "[$CASENO]$desc"
148 eval_result() { # sigval
149 case $1 in
150 $PASS)
151 prlog " [PASS]"
152 PASSED_CASES="$PASSED_CASES $CASENO"
153 return 0
155 $FAIL)
156 prlog " [FAIL]"
157 FAILED_CASES="$FAILED_CASES $CASENO"
158 return 1 # this is a bug.
160 $UNRESOLVED)
161 prlog " [UNRESOLVED]"
162 UNRESOLVED_CASES="$UNRESOLVED_CASES $CASENO"
163 return 1 # this is a kind of bug.. something happened.
165 $UNTESTED)
166 prlog " [UNTESTED]"
167 UNTESTED_CASES="$UNTESTED_CASES $CASENO"
168 return 0
170 $UNSUPPORTED)
171 prlog " [UNSUPPORTED]"
172 UNSUPPORTED_CASES="$UNSUPPORTED_CASES $CASENO"
173 return 1 # this is not a bug, but the result should be reported.
175 $XFAIL)
176 prlog " [XFAIL]"
177 XFAILED_CASES="$XFAILED_CASES $CASENO"
178 return 0
181 prlog " [UNDEFINED]"
182 UNDEFINED_CASES="$UNDEFINED_CASES $CASENO"
183 return 1 # this must be a test bug
185 esac
188 # Signal handling for result codes
189 SIG_RESULT=
190 SIG_BASE=36 # Use realtime signals
191 SIG_PID=$$
193 SIG_FAIL=$((SIG_BASE + FAIL))
194 trap 'SIG_RESULT=$FAIL' $SIG_FAIL
196 SIG_UNRESOLVED=$((SIG_BASE + UNRESOLVED))
197 exit_unresolved () {
198 kill -s $SIG_UNRESOLVED $SIG_PID
199 exit 0
201 trap 'SIG_RESULT=$UNRESOLVED' $SIG_UNRESOLVED
203 SIG_UNTESTED=$((SIG_BASE + UNTESTED))
204 exit_untested () {
205 kill -s $SIG_UNTESTED $SIG_PID
206 exit 0
208 trap 'SIG_RESULT=$UNTESTED' $SIG_UNTESTED
210 SIG_UNSUPPORTED=$((SIG_BASE + UNSUPPORTED))
211 exit_unsupported () {
212 kill -s $SIG_UNSUPPORTED $SIG_PID
213 exit 0
215 trap 'SIG_RESULT=$UNSUPPORTED' $SIG_UNSUPPORTED
217 SIG_XFAIL=$((SIG_BASE + XFAIL))
218 exit_xfail () {
219 kill -s $SIG_XFAIL $SIG_PID
220 exit 0
222 trap 'SIG_RESULT=$XFAIL' $SIG_XFAIL
224 __run_test() { # testfile
225 # setup PID and PPID, $$ is not updated.
226 (cd $TRACING_DIR; read PID _ < /proc/self/stat ; set -e; set -x; . $1)
227 [ $? -ne 0 ] && kill -s $SIG_FAIL $SIG_PID
230 # Run one test case
231 run_test() { # testfile
232 local testname=`basename $1`
233 local testlog=`mktemp $LOG_DIR/${testname}-log.XXXXXX`
234 testcase $1
235 echo "execute: "$1 > $testlog
236 SIG_RESULT=0
237 if [ $VERBOSE -ne 0 ]; then
238 __run_test $1 2>> $testlog | tee -a $testlog
239 else
240 __run_test $1 >> $testlog 2>&1
242 eval_result $SIG_RESULT
243 if [ $? -eq 0 ]; then
244 # Remove test log if the test was done as it was expected.
245 [ $KEEP_LOG -eq 0 ] && rm $testlog
246 else
247 catlog $testlog
248 TOTAL_RESULT=1
252 # load in the helper functions
253 . $TEST_DIR/functions
255 # Main loop
256 for t in $TEST_CASES; do
257 run_test $t
258 done
260 prlog ""
261 prlog "# of passed: " `echo $PASSED_CASES | wc -w`
262 prlog "# of failed: " `echo $FAILED_CASES | wc -w`
263 prlog "# of unresolved: " `echo $UNRESOLVED_CASES | wc -w`
264 prlog "# of untested: " `echo $UNTESTED_CASES | wc -w`
265 prlog "# of unsupported: " `echo $UNSUPPORTED_CASES | wc -w`
266 prlog "# of xfailed: " `echo $XFAILED_CASES | wc -w`
267 prlog "# of undefined(test bug): " `echo $UNDEFINED_CASES | wc -w`
269 # if no error, return 0
270 exit $TOTAL_RESULT